import java.awt.*;
import java.awt.event.*;
import java.util.*;
import bsh.Interpreter;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.io.*;
import java.lang.reflect.*;

public class Bild extends JFrame
implements ActionListener, Runnable, MouseListener, TextListener, MouseMotionListener
{
    private ScrollPane klassenPanel;
    private ScrollPane programmPanel;
    private ScrollPane objectPanel;
    private ScrollPane bildPanel;
    public Thread th;
    private boolean leer=true;
    private Container klassen;
    private Label xyLabel;
    private static boolean z=false;
    boolean textGeaendert=false;
    public static Stack<Figur> figuren;

    private MenuBar menuBar;
    private Menu datei,bild,ansicht,hilfe;
    private MenuItem laden,speichern,ende,neuZeichnen,stop,loeschen,markierung,kartenAn,kartenAus,textAn,textAus,doc,auto,nichtauto,neu;

    private Reader reader;
    private Interpreter i;
    private Blatt pane;
    private TextArea text;
    private Objektkarte objektkarte;
    private String[] farben;

    private Karte meth;
    private JLabel lab=new JLabel("");
    private Frame hilfefenster;

    public String befehl="";

    private Panel textPanel;
    // private boolean erlaubeWarte=true;
  public static final String fs = "/";
    public static void main(String[] args)
    {
        try{UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());}catch(Exception e){}
        Bild b=new Bild();
    }

    public Bild()
    {
        this.setSize((int)(this.getToolkit().getScreenSize().width),(int)(this.getToolkit().getScreenSize().height));
        this.setLocation(0,0);
        this.addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){System.exit(0);}});
        this.setIconImage(this.getToolkit().getImage("./bin/nt.gif"));
        this.setLayout(new BorderLayout());

        figuren=new Stack<Figur>();
        klassen=new Container();
        klassenPanel=new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED)
        {
            public Dimension getPreferredSize(){return new Dimension(klassen.getPreferredSize().width+6,klassen.getPreferredSize().height+10);}
        };

        this.add("South",klassenPanel);
        klassenPanel.add(klassen);

        klassen.setLayout(new GridLayout(1,6));

        this.pane=new Blatt(this.figuren);
        this.text=new TextArea();
        text.setText("Programmfenster");

        textPanel=new Panel();
        textPanel.setLayout(new BorderLayout());
        xyLabel=new Label();

        this.text.addTextListener(this);
        this.add("Center",pane);
        this.add("West",textPanel);
        textPanel.add("Center",text);
        textPanel.add("North",xyLabel);
        pane.addMouseMotionListener(this);
        pane.addMouseListener(this);

        objektkarte=new Objektkarte(this,text);
        Container c=new Container();
        c.setLayout(new BorderLayout());
        c.add("North",objektkarte);
        klassen.add(c);
        pane.addMouseListener(objektkarte);
        registerKarte(new Rechteck());
        registerKarte(new Dreieck());
        registerKarte(new Kreis());
        registerKarte(new Ellipse());
        registerKarte(new Linie());
        meth=new Karte(new Rechteck(),true);

        z=true;

        menuBar=new MenuBar();
        setMenuBar(menuBar);

        datei=new Menu("Datei");
        menuBar.add(datei);

        laden=new MenuItem("Oeffnen ...");
        laden.addActionListener(this);
        laden.setActionCommand("laden");
        datei.add(laden);

        speichern=new MenuItem("Speichern unter ...");
        speichern.addActionListener(this);
        speichern.setActionCommand("speichern");
        datei.add(speichern);

        neu=new MenuItem("Programmfenster loeschen");
        neu.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    crlf();
                    text.setText("\r\n");
                }
            });
        datei.add(neu);

        ende=new MenuItem("Beenden");
        ende.addActionListener(this);
        ende.setActionCommand("ende");
        datei.add(ende);

        bild=new Menu("Bild");
        menuBar.add(bild);

        neuZeichnen=new MenuItem("Bild neu zeichnen");
        neuZeichnen.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    crlf();
                    anhalten();
                    zeichne();
                }

            });
        bild.add(neuZeichnen);

        stop=new MenuItem("Bewegungen anhalten");
        stop.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    crlf();
                    anhalten();
                }

            });
        bild.add(stop);

        loeschen=new MenuItem("Zeichenflaeche loeschen");
        loeschen.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    crlf();
                    loeschen();
                }

            });
        bild.add(loeschen);

        markierung=new MenuItem("Markierung ausfuehren");
        markierung.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    crlf();
                    zeichneAusschnitt();
                    neu();
                }

            });
        bild.add(markierung);

        ansicht=new Menu("Ansicht");
        menuBar.add(ansicht);

        kartenAn=new MenuItem("Klassenkarten anzeigen");
        kartenAn.addActionListener(this);
        kartenAn.setActionCommand("klassenAn");
        ansicht.add(kartenAn);

        kartenAus=new MenuItem("Klassenkarten ausblenden");
        kartenAus.addActionListener(this);
        kartenAus.setActionCommand("klassenAus");
        ansicht.add(kartenAus);

        textAn=new MenuItem("Programmfenster anzeigen");
        textAn.addActionListener(this);
        textAn.setActionCommand("textAn");
        ansicht.add(textAn);

        textAus=new MenuItem("Programmfenster ausblenden");
        textAus.addActionListener(this);
        textAus.setActionCommand("textAus");
        ansicht.add(textAus);

        textAn.setEnabled(false);
        textAus.setEnabled(true);
        kartenAn.setEnabled(true);
        kartenAus.setEnabled(false);

        auto=new MenuItem("Zeichenfenster automatisch in den Vordergrund");
        auto.addActionListener(this);
        auto.setActionCommand("auto");
        ansicht.add(auto);

        nichtauto=new MenuItem("Zeichenfenster manuell in den Vordergrund");
        nichtauto.addActionListener(this);
        nichtauto.setActionCommand("nichtauto");
        ansicht.add(nichtauto);

        textAn.setEnabled(false);
        textAus.setEnabled(true);
        kartenAn.setEnabled(true);
        kartenAus.setEnabled(false);
        auto.setEnabled(true);
        nichtauto.setEnabled(false);
        automatisch=false;

        hilfe=new Menu("?");
        menuBar.add(hilfe);

        doc=new MenuItem("Hilfe");
        doc.addActionListener(this);
        doc.setActionCommand("doc");
        hilfe.add(doc);

        this.setVisible(true);
        i=new Interpreter();
        try{
            i.set("bild",this);
            i.source("./bin/def.txt");
            //if(erlaubeWarte)
            //i.eval("void warte(int zeit){bild.warten(zeit);}");
            i.eval("void zeichenflaecheSetzen(int x, int y){bild.setzeZeichenflaeche(x,y);}");
            i.eval("void warten(int zeit){bild.warten(zeit);}");
        }catch(Exception e){System.out.println(e);}

        this.setTitle("JGraphik - Bildbeschreibungssprache in Punktnotaion");

        klassenPanel.setVisible(false);

        neuAnordnen();
        pane.getGraphics().drawString("Zeichenflache",20,20);
    }

    public void actionPerformed(ActionEvent e)
    {
        crlf();

        if(e.getActionCommand()=="laden")
        {
            FileDialog fd = new FileDialog(this,"Bild laden",FileDialog.LOAD);
            fd.show();
            String datei = fd.getDirectory()+fs+fd.getFile();
            try{
                BufferedReader in=new BufferedReader(new FileReader(datei));
                text.setText("");
                String txt;
                while((txt = in.readLine())!=null)
                {
                    text.append(txt+'\r'+'\n');
                }
                in.close();
            }catch(Exception e1){System.out.println(e1);}
        }

        if(e.getActionCommand()=="speichern")
        {
            FileDialog fd = new FileDialog(this,"Bild speichern",FileDialog.SAVE);
            fd.show();
            String datei = fd.getDirectory()+fs+fd.getFile();

            try{
                BufferedWriter out=new BufferedWriter(new FileWriter(datei));
                String txt=text.getText();
                out.write(txt,0,txt.length());
                out.close();
            }catch(Exception e2){System.out.println(e2);}
        }
        if(e.getActionCommand()=="ende")
        {
            System.exit(0);
        }

        if(e.getActionCommand()=="klassenAn")
        {
            klassenPanel.setVisible(true);
            neuAnordnen();
            kartenAn.setEnabled(false);
            kartenAus.setEnabled(true);
            merkeKarten=true;
        }

        if(e.getActionCommand()=="klassenAus")
        {
            klassenPanel.setVisible(false);
            neuAnordnen();
            kartenAn.setEnabled(true);
            kartenAus.setEnabled(false);
            merkeKarten=false;
        }
        if(e.getActionCommand()=="textAn")
        {
            textPanel.setVisible(true);
            neuAnordnen();
            textAn.setEnabled(false);
            textAus.setEnabled(true);
            merkeText=true;
        }

        if(e.getActionCommand()=="textAus")
        {
            textPanel.setVisible(false);
            neuAnordnen();
            textAn.setEnabled(true);
            textAus.setEnabled(false);
            merkeText=false;
        }

        if(e.getActionCommand()=="auto")
        {
            automatisch=true;
            auto.setEnabled(false);
            nichtauto.setEnabled(true);
        }

        if(e.getActionCommand()=="nichtauto")
        {
            automatisch=false;
            auto.setEnabled(true);
            nichtauto.setEnabled(false);
        }

        if(e.getActionCommand()=="doc")
        {
            hilfefenster=new Frame(this.getTitle());
            hilfefenster.addWindowListener
            (
                new WindowAdapter()
                {
                    public void windowClosing(WindowEvent e)
                    {
                        hilfefenster.dispose();
                    }
                }
            );
            hilfefenster.setIconImage(this.getToolkit().getImage("."+fs+"bin"+fs+"nt.gif"));
            hilfefenster.setSize((int)(this.getToolkit().getScreenSize().width*0.7),(int)(this.getToolkit().getScreenSize().height*0.7));
            hilfefenster.setLocation(0,0);
            try
            {
                JEditorPane jp=new JEditorPane();
                HTMLEditorKit ek=new HTMLEditorKit();
                jp.setContentType("text/html");
                String datei = "."+fs+"doc"+fs+"hilfe.html";
                BufferedReader in=new BufferedReader(new FileReader(datei));
                Document doc=ek.createDefaultDocument();
                ek.read(in,doc,0);
                in.close();
                jp.setDocument(doc);
                jp.setEditable(false);
                hilfefenster.add(new JScrollPane(jp));
            }catch(Exception ed){System.out.println(ed);}
            hilfefenster.setVisible(true);
        }
    }

    public String[] getFarben()
    {
        String farbDatei = "bin"+fs+"def.txt";
        System.out.println(farbDatei);
        try{
            BufferedReader in=new BufferedReader(new FileReader(farbDatei));
            Vector<String> tmp=new Vector<>();
            String zeile="";
            String fa="";
            while((zeile = in.readLine())!=null)
            {
                StringTokenizer st=new StringTokenizer(zeile,"=");
                if(st.hasMoreElements())
                {
                    fa=(String)st.nextElement();
                }
                if(!fa.equals(""))
                {
                    tmp.add(fa);
                }
            }
            in.close();
            farben=new String[tmp.size()];
            for(int i=0;i<tmp.size();i++)
            {
                farben[i] =tmp.elementAt(i);
            }
        }catch(Exception e1){System.out.println(e1);farben=new String[] {"rot","blau","gruen","gelb","schwarz","weiss","grau"};}
        return farben;
    }

    public static void addElement(Figur f)
    {
        if(z)
        {
            figuren.add(f);
        }
    }

    public Blatt getBlatt()
    {
        return pane;
    }

    public void inDenVordergrund(Figur f)
    {
        figuren.removeElement(f);
        figuren.addElement(f);
    }

    public void inDenHintergrund(Figur f)
    {
        figuren.removeElement(f);
        figuren.insertElementAt(f,0);
    }

    public void nachVorne(Figur f)
    {
        int pos=figuren.indexOf(f);
        if(pos<figuren.size()-1&pos>-1)
        {
            figuren.removeElement(f);
            figuren.insertElementAt(f,pos+1);
        }
    }

    public void nachHinten(Figur f)
    {
        int pos=figuren.indexOf(f);
        if(pos>0)
        {
            figuren.removeElement(f);
            figuren.insertElementAt(f,pos-1);
        }
    }

    private void registerKarte(Figur f)
    {
        Container c=new Container();
        c.setLayout(new BorderLayout());
        Karte k=new Karte(f,this);
        k.addMouseListener(this);
        c.add("North",k);
        klassen.add(c);
    }

    public void neuAnordnen()
    {
        pane.doLayout();
        klassen.doLayout();
        doLayout();
        validate();
    }

    public void crlf()
    {
        if(textGeaendert)
        {
            boolean neu=false;
            StringBuffer sb=new StringBuffer(text.getText());
            if(sb.length()>0)
            {
                if(sb.charAt(0)=='\n')
                {
                    sb.insert(0,"\r");
                    neu=true;
                }
                boolean notende=true;
                int idx=1;
                while(notende)
                {
                    if(sb.charAt(idx)=='\n' & sb.charAt(idx-1)!='\r')
                    {
                        sb.insert(idx,"\r");
                        neu=true;
                        idx++;
                    }
                    idx++;
                    notende=idx<text.getText().length();
                }
            }
            if(neu)
            {
                text.setText(sb.toString());
            }
            textGeaendert=false;
        }
    }

    private void zeichne()
    {
        th=new Thread(this);
        th.start();
    }

    public void warten(int zeit)
    {
        setBild();
        neu();
        try
        {
            Thread.currentThread().sleep(zeit);
        }catch(Exception e){System.out.println(e);}
    }

    public void setzeZeichenflaeche(int breite, int hoehe)
    {
        pane.setFlaeche(breite,hoehe);
    }

    private void setBild()
    {
        for(int i=0;i<figuren.size();i++)
        {
            ((Figur)figuren.elementAt(i)).setBild(this);
        }
    }

    public void neu()
    {
        pane.repaint();
    }

    public void zeichneAusschnitt()
    {
        try
        {
            i.eval(text.getSelectedText());
        }catch(Exception e){}
    }

    public void befehlAusfuehren()
    {
        try
        {
            i.eval(befehl);
        }catch(Exception e){}
    }

    public void run()
    {
        //System.out.println("run");
        figuren.clear();
        try
        {
            i.eval(text.getText());
        }catch(Exception e)
        {
            System.err.println(e);
            //****************************** Fehlermeldung von bsh auswerten
            //****************************** und Fehler im Programmfenster markieren
            Class c=e.getClass();
            int zeile=0;
            if(c.getName().equals("bsh.ParseException"))
            {
                String f=(""+e);
                int anfang=f.indexOf("line")+5;
                int ende=f.indexOf(",",anfang);
                String z=f.substring(anfang,ende);
                zeile=Integer.parseInt(z);
            }
            else
            {
                try{zeile=((bsh.EvalError)e).getErrorLineNumber();}catch(Exception ee){System.out.println(ee);}
            }
      //System.out.println(zeile);
            String befehle=text.getText();
      String[] befehlArr=befehle.split("\n");
      zeile--;
      int chars=0;
      for(int i=0;i<zeile;i++){
        chars+=befehlArr[i].length()-1;
      }
      chars++;
      //System.out.println("char: "+befehle.charAt(chars));
      while(befehle.charAt(chars)=='\n') chars++;
            /*StringTokenizer st=new StringTokenizer(befehle,"\n");
      
            int fehler=0;
            int leerzeilen=0;
            int leerzeilenHang=0;
            int zeilenlaenge=0;
            int aktuelleZeile=0;
            while(st.hasMoreElements()&&aktuelleZeile<zeile)
            {
                String befehl=(String)st.nextElement();
                int aktuellerBefehl=befehl.length()+1;
                leerzeilenHang=leerzeilen;
                if(aktuellerBefehl<3)
                {
                    leerzeilen+=1;
                }
                else
                {
                    leerzeilen=0;
                }
                fehler+=befehl.length()+1;
                zeilenlaenge=befehl.length();
                aktuelleZeile++;
            }*/
            text.setSelectionStart(chars);
            text.setSelectionEnd(chars+befehlArr[zeile].length()+zeile-1);
        }
        setBild();  
        neu();
    }

    private void anhalten()
    {
        try{i.eval("bild.th.stop();");}catch(Exception e2){};
        for(int i=0;i<figuren.size();i++)
        {
            figuren.elementAt(i).BewegungBeenden();
        }
    }

    public void loeschen()
    {
        anhalten();
        figuren.clear();
        neu();
    }

    public void neuzeichnen()
    {
        anhalten();
        zeichne();
    }

    public void setFadenkreuz(boolean b)
    {
        pane.fadenkreuz=b;
        if(!b)pane.loescheFadenkreuz();
    }

    public void mouseClicked(MouseEvent e){}

    public void textValueChanged(TextEvent e)
    {
        textGeaendert=true;
    }

    public void mousePressed(MouseEvent e){}

    public void mouseReleased(MouseEvent e)
    {
        if(!e.isPopupTrigger())
        {
            Karte karte;
            if(meth.getClass()==e.getSource().getClass())
            {
                karte=(Karte)(e.getComponent());
                objektkarte.setKarte(karte);
                pane.fadenkreuz=true;
                neuAnordnen(); 
            }
            else if(lab.getClass()==e.getSource().getClass())
            {
                JLabel label=(JLabel)(e.getComponent());
                karte=(Karte)(label.getParent());
                objektkarte.setKarte(karte);
                pane.fadenkreuz=true;
                neuAnordnen(); 
            }
        }
        if(e.getSource()==pane)
        {
            if(ausgeblendet&automatisch)
            {
                ausgeblendet=false;
                boolean neu=false;
                if(merkeKarten)
                {
                    klassenPanel.setVisible(true);
                    kartenAn.setEnabled(false);
                    kartenAus.setEnabled(true);
                    merkeKarten=false;
                    neu=true;
                }
                if(merkeText)
                {
                    textPanel.setVisible(true);
                    textAn.setEnabled(false);
                    textAus.setEnabled(true);
                    merkeText=false;
                    neu=true;
                }
                if(neu)neuAnordnen();
            }
        }
    }

    boolean merkeText=false;
    boolean merkeKarten=false;
    boolean ausgeblendet=false;
    boolean automatisch;
    public void mouseEntered(MouseEvent e)
    {
        //System.out.println("entered");
        if(automatisch&objektkarte.isVisible()&e.getSource()==pane)
        {
            ausgeblendet=true;
            if(klassenPanel.isVisible())
            {
                klassenPanel.setVisible(false);
                kartenAn.setEnabled(true);
                kartenAus.setEnabled(false);
                merkeKarten=true;
            }
            else
            {
                merkeKarten=false;
            }
            if(textPanel.isVisible())
            {
                textPanel.setVisible(false);
                textAn.setEnabled(true);
                textAus.setEnabled(false);
                merkeText=true;
            }
            else
            {
                merkeText=false;
            }
            if(merkeKarten|merkeText)neuAnordnen();
        }
    }

    public void mouseExited(MouseEvent e)
    {
        //System.out.println("exited");
        if(e.getSource()==pane)
        {
            if(leer)
            {
                text.setText("");
                leer=false;
            }
            clearLabel();
            if(ausgeblendet&automatisch)
            {
                ausgeblendet=false;
                boolean neu=false;
                if(merkeKarten)
                {
                    klassenPanel.setVisible(true);
                    kartenAn.setEnabled(false);
                    kartenAus.setEnabled(true);
                    merkeKarten=false;
                    neu=true;
                }
                if(merkeText)
                {
                    textPanel.setVisible(true);
                    textAn.setEnabled(false);
                    textAus.setEnabled(true);
                    merkeText=false;
                    neu=true;
                }
                if(neu)neuAnordnen();
            }
        }
    }

    private void clearLabel()
    {
        xyLabel.setText("");
    }

    private void setLabel(MouseEvent e)
    {
        xyLabel.setText("links: "+e.getX()+"    oben: "+e.getY());
    }

    public void mouseMoved(MouseEvent e)
    {
        setLabel(e);
    }

    public void mouseDragged(MouseEvent e)
    {
        setLabel(e);
    }
}
