import java.awt.*;
import java.awt.geom.*;

public class Dreieck extends Figur
{
	private int breite, hoehe, oben, links;
	private int l[];
	private int o[];
	private int x, y;
	private boolean neu=true;

	public Dreieck()
	{
		breite=100;
		hoehe=100;
		links=20;
		oben=20;
		farbe=Color.black;

		addArg(new Argument("links","20","Abstand vom linken Rand","xmin"));
		addArg(new Argument("oben","20","Abstand vom oberen Rand","ymin"));
		addArg(new Argument("breite","100","Breite des Dreiecks","adx"));
		addArg(new Argument("hoehe","100","Hoehe des Dreiecks (negativ: Spitze oben)","dy"));
		addMet(new Methode("linksSetzen(links)","setzt den Abstand des Objekts vom linken Rand"));
        addMet(new Methode("obenSetzen(oben)","setzt den Abstand des Objekts vom oberen Rand"));
        addMet(new Methode("breiteSetzen(breite)","setzt die Breite des Dreiecks"));
        addMet(new Methode("hoeheSetzen(hoehe)","setzt die Hoehe des Dreiecks (negativ: Spitze oben)"));
        refresh();
	}
	public void linksSetzen(int in){
		links=in;
	}
	public void obenSetzen(int in){
		oben=in;
	}
	public void breiteSetzen(int in){
		breite=in;
	}
	public void hoeheSetzen(int in){
		hoehe=in;
	}
	public Shape getShape()
	{
		GeneralPath p=new GeneralPath();
		if(hoehe>0)
		{
			p.moveTo(links,oben);
			p.lineTo(links+breite,oben);
			p.lineTo(links+(int)(breite/2),oben+hoehe);
		}
		else
		{
			p.moveTo(links,oben-hoehe);
			p.lineTo(links+breite,oben-hoehe);
			p.lineTo(links+(int)(breite/2),oben);
		}
		p.closePath();
		return p;
	}
	public Dimension getMittelpunkt()
	{
		return new Dimension(links+(int)(breite/2),oben+Math.abs((int)(hoehe/2)));
	}
	public void verschiebe(int dx, int dy)
	{
		if(neu)
		{
			x=links*faktor;
			y=oben*faktor;
			neu=false;
		}
		x+=dx*faktor;
		y+=dy*faktor;
		links+=dx;
		oben+=dy;
	}
	public void verschiebe1(int dx, int dy)
	{
		if(neu)
		{
			x=links*faktor;
			y=oben*faktor;
			neu=false;
		}
		x+=dx;
		y+=dy;
		links=(int)x/faktor;
		oben=(int)y/faktor;
	}
	public void setGrenzen()
	{
		xmin=links;
		xmax=links+breite;
		if(hoehe>0)
		{
			ymin=oben;
			ymax=oben+hoehe;
		}
		else
		{
			ymax=oben;
			ymin=oben+hoehe;
		}
	}
}
