import java.awt.*;
import java.util.*;
import java.awt.geom.*;

public abstract class Figur
{
    protected Bild bild;
    protected int xmin, ymin, xmax, ymax;
    private boolean sichtbar=true;
    private float winkel=0;
    private int vx,vy;
    private int vfall,vhuepf;
    private int omega=0;
    private int unten=0;
    protected Color farbe;
    private static int nummer=0;
    private Vector<Argument> argumente;
    private Vector<Methode> methoden;
    public int linienbreite=0;
    private Argument[] argArray;
    private Methode[] metArray;
    private Thread thW, thR, thF, thH;
    private boolean goW, goH, goR, goF;
    public static int blattbreite=1000;
    public static int blatthoehe=1000;
    private int drehX=0;
    private int drehY=0;
    private boolean autodrehpunkt=true;
    public static int faktor=100;
    private static float faktorW=10;

    public Figur()
    {
        Bild.addElement(this);
        argumente=new Vector<Argument>();
        methoden=new Vector<Methode>();
        argumente.add(new Argument("farbe","grau","Farbe des Objekts"));

        addMet(new Methode("verschieben(nachRechts,nachUnten)","verschiebt das Objekt - auch negative Werte sind erlaubt"));
        addMet(new Methode("drehen(Winkel)","dreht das Objekt gegen den Uhrzeigersinn"));
        addMet(new Methode("drehpunktSetzen(links,oben)","setzt den Drehpunkt des Objekts - gemessen von den Bildraendern"));
        addMet(new Methode("wandern(nachRechts,nachUnten)","setzt das Objekt in Bewegung - groessere Werte entsprechen groesseren Geschwindigkeiten"));
        addMet(new Methode("wandernBeenden()","Beendet wandere()"));
        addMet(new Methode("rotieren(Drehgeschwindigkeit)","dreht das Objekt immer weiter"));
        addMet(new Methode("rotationBeenden()","beendet rotiere()"));
        addMet(new Methode("fallen()","laesst das Objekt mit zunehmender Geschwindigkeit nach unten fallen"));
        addMet(new Methode("fallenBeenden()","beendet falle()"));
        addMet(new Methode("huepfen(Boden)","laesst das Objekt huepfen - Boden ist der Abstand des Bodens vom oberen Rand"));
        addMet(new Methode("huepfenBeenden()","beendet huepfe()"));
        addMet(new Methode("nachVorne()","rueckt die Figur eins nach vorne"));
        addMet(new Methode("inDenVordergrund()","setzt die Figur ganz nach vorne"));
        addMet(new Methode("nachHinten()","rueckt die Figur eins nach hinten"));
        addMet(new Methode("inDenHintergrund()","setzt die Figur ganz nach hinten"));
        addMet(new Methode("ausblenden()","macht die Figur unsichtbar"));
        addMet(new Methode("einblenden()","macht die Figur wieder sichtbar"));
        addMet(new Methode("farbeSetzen(farbe)","Setzt die Farbe des Objekts"));
        //refresh();
    }
	public void farbeSetzen(Color in){
		farbe=in;
	}
    protected void refresh(){
        metArray = new Methode[methoden.size()];
        metArray=methoden.toArray(metArray);
    }
    public void verschieben(int x, int y){
	verschiebe(x,y);
    }
    public void addArg(Argument a)
    {
        argumente.add(a);
    }

    public void addMet(Methode m)
    {
        methoden.add(m);
    }

    public static int getNummer()
    {
        return nummer;
    }
    public static void incNummer()
    {
        nummer++;
    }

    public void setBild(Bild bild)
    {
        this.bild=bild;
    }

    public void DrehpunktSetzen(int x, int y)
    {
        drehX=x;
        drehY=y;
        autodrehpunkt=false;
    }

    public Argument[] getArguments()
    {
        if(argArray==null)
        {
            argArray = new Argument[argumente.size()];
            argArray=argumente.toArray(argArray);
        }
        return argArray;
    }
    public Methode[] getMethods()
    {
        return metArray;
    }

    public void drehen(int winkel)
    {
        this.winkel-=winkel;
        if(bild!=null)
        {
            bild.neu();
        }
    }
    
    public void ausblenden()
    {
        sichtbar=false;
    }
    
    public void einblenden()
    {
        sichtbar=true;
    }

    public void fallen()
    {
        vfall=0;
        goF=true;
        setGrenzen();
        Runnable r=new Runnable()
        {
            public void run()
            {
                while( goF & ymin<blatthoehe )
                {
                    verschiebe(0,(int)(vfall++/3));
                    setGrenzen();
                    if(bild!=null)
                    {
                        bild.neu();
                    }
                    try{Thread.currentThread().sleep(100);}catch(Exception e){}
                }
            }
        };
        thF=new Thread(r);
        thF.start();
    }

    public void huepfen(int u)
    {
        unten=u;
        vhuepf=0;
        goH=true;
        setGrenzen();
        Runnable r=new Runnable(){public void run()
        {
            while( goH )
            {
                vhuepf++;
                verschiebe(0,(int)(vhuepf/3));
                setGrenzen();
                if(ymax>unten)          //blatthoehe
                {
                    vhuepf=-vhuepf-1;
                }
                if(bild!=null)
                {
                    bild.neu();
                }
                try{Thread.currentThread().sleep(30);}catch(Exception e){}
            }
        }};
        thH=new Thread(r);
        thH.start();
    }

    public void wandern(int x, int y)
    {
        goW=true;
        this.vx=x;
        this.vy=y;
        if(vx!=0|vy!=0)
        {
            setGrenzen();
            Runnable r=new Runnable(){public void run()
            {
                while( goW & ( (vx>0&xmin<blattbreite) | (vx<0&xmax>0) | (vy>0&ymin<blatthoehe) | (vy<0&ymax>0) ) )
                {
                    verschiebe1(vx,vy);
                    setGrenzen();
                    if(bild!=null)
                    {
                        bild.neu();
                    }
                    try{Thread.currentThread().sleep(100);}catch(Exception e){}
                }
            }};
            thW=new Thread(r);
            thW.start();
        }
    }

    public void rotieren(int w)
    {
        omega=w;
        goR=true;
        Runnable r=new Runnable(){public void run()
        {
            while(goR)
            {
                winkel-=omega/faktorW;
                if(bild!=null)
                {
                    bild.neu();
                }
                try{Thread.currentThread().sleep(100);}catch(Exception e){}
            }
        }};
        thR=new Thread(r);
        thR.start();
    }

    public Dimension getDrehpunkt()
    {
        if(autodrehpunkt)
        {
            return getMittelpunkt();
        }
        else
        {
            return new Dimension(drehX, drehY);
        }
    }

    public void inDenVordergrund()
    {
        Runnable r=new Runnable(){public void run()
        {
            while(bild==null)
            {
                try{Thread.currentThread().sleep(100);}catch(Exception e){}
            }
            idv();
        }};
        Thread thx=new Thread(r);
        thx.start();
    }
    private void idv()
    {
        bild.inDenVordergrund(this);
    }

    public void inDenHintergrund()
    {
        Runnable r=new Runnable()
        {
            public void run()
            {
                while(bild==null)
                {
                    try{Thread.currentThread().sleep(100);}catch(Exception e){}
                }
                idh();
            }
        };
        Thread thx=new Thread(r);
        thx.start();
    }
    
    private void idh()
    {
        bild.inDenHintergrund(this);
    }
    
    public void nachVorne()
    {
        Runnable r=new Runnable(){public void run()
        {
            while(bild==null)
            {
                try{Thread.currentThread().sleep(100);}catch(Exception e){}
            }
            nv();
        }};
        Thread thx=new Thread(r);
        thx.start();
    }
    
    private void nv()
    {
        bild.nachVorne(this);
    }
    
    public void nachHinten()
    {
        Runnable r=new Runnable()
        {
            public void run()
            {
                while(bild==null)
                {
                    try{Thread.currentThread().sleep(100);}catch(Exception e){}
                }
                nh();
            }
        };
        Thread thx=new Thread(r);
        thx.start();
    }
    
    private void nh()
    {
        bild.nachHinten(this);
    }
    
    public void BewegungBeenden()
    {
        WanderungBeenden();
        HuepfenBeenden();
        RotationBeenden();
        FallBeenden();
    }
    
    public void WanderungBeenden()
    {
        goW=false;
    }
    
    public void RotationBeenden()
    {
        goR=false;
        Dimension ort=getDrehpunkt();
        int x0=ort.width;
        int y0=ort.height;
        autodrehpunkt=true;
        Dimension ist=getDrehpunkt();
        int xa=ist.width;
        int ya=ist.height;
        int dx=xa-x0;
        int dy=ya-y0;
        double w=Math.toRadians(winkel);
        int xb=x0+(int)(dx*Math.cos(w)-dy*Math.sin(w));
        int yb=y0+(int)(dy*Math.cos(w)+dx*Math.sin(w));
        verschiebe(xb-xa,yb-ya);
    }
    
    public void FallBeenden()
    {
        goF=false;
    }
    
    public void HuepfenBeenden()
    {
        goH=false;
    }

    public void paint (Graphics2D g)
    {
        if(sichtbar)
        {
            g.setColor(farbe);
            Shape s=getShape();
            int x=getDrehpunkt().width;
            int y=getDrehpunkt().height;

            AffineTransform t1=new AffineTransform();
            t1.setToTranslation(-x,-y);
            AffineTransform t2=new AffineTransform();
            t2.rotate(Math.toRadians(winkel));
            AffineTransform t3=new AffineTransform();
            t3.setToTranslation(x,y);
            t1.preConcatenate(t2);
            t1.preConcatenate(t3);

            Shape tr=t1.createTransformedShape(s);
            g.fill(tr);
            if(linienbreite>0)
            {
                g.setStroke(new BasicStroke(linienbreite,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));
                g.draw(tr);
                g.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));
            }
        }
    }
    
    public abstract Shape getShape();
    public abstract Dimension getMittelpunkt();
    public abstract void verschiebe(int x, int y);
    public abstract void verschiebe1(int x, int y);
    public abstract void setGrenzen();
}
