import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.*;
import java.util.*;

public class Karte extends Panel implements SchriftListener
{
    SchriftPopup sp;
    String name="";
    int randInnen=10;
    int randAussen=10;
    int hoehe=100;
    int breite=100;
    int mbreite=100;
    public static int schriftgroesse=12;
    static int maxhoehe=100;
    static int maxbreite=10;
    static int maxMbreite=10;
    static int kartenzahl=0;
    private boolean met=false;
    public Figur f;
    Argument[] argumente;
    Methode[] methoden;
    private Bild bild;

    public static Vector<Karte> karten=new Vector<Karte>();
    public Karte(Figur f,boolean met)
    {
        this.met=met;
        this.argumente=new Argument[1];
        argumente[0]=new Argument("...","","siehe Klassenkarten");
        this.methoden=f.getMethods();
        this.name="Alle Klassen";
    }

    public void neuZeichnen()
    {
        for(int i=0;i<karten.size();i++)
        {
            Karte k=karten.elementAt(i);
            k.neuLaden();
        }
    }

    public void setSchriftgroesse(int s)
    {
        schriftgroesse=s;
        neuZeichnen();
        bild.neuAnordnen();
    }

    public int getSchriftgroesse()
    {
        return schriftgroesse;
    }

    public static Dimension getGesamtGroesse()
    {
        return new Dimension(kartenzahl*maxbreite+maxMbreite,maxhoehe+6);
    }


    public void neuLaden()
    {
        removeAll();
        setLayout(new GridLayout(argumente.length+methoden.length+1,1));
        JLabel l=new JLabel(name,JLabel.CENTER);
        add(l);
        l.setFont(new Font("SansSerif",Font.BOLD,schriftgroesse));
        l.addMouseListener(bild);
        l.addMouseListener(sp);

        for(int i=0;i<argumente.length;i++)
        {
            Argument a=argumente[i];
            l=new JLabel("     "+a.name+"     ");
            l.setFont(new Font("SansSerif",Font.PLAIN,schriftgroesse));
            l.setToolTipText(a.beschreibung);
            add(l);
            l.addMouseListener(bild);
            l.addMouseListener(sp);
        }
        for(int i=0;i<methoden.length;i++)
        {
            Methode a=methoden[i];
            l=new JLabel("     "+a.name+"     ");
            l.setFont(new Font("SansSerif",Font.PLAIN,schriftgroesse));
            l.setToolTipText(a.beschreibung);
            l.addMouseListener(bild);
            l.addMouseListener(sp);
            add(l);
        }
        doLayout();
    }

    public Karte(Figur f, Bild bild)
    {
        karten.add(this);
        this.bild=bild;
        sp=new SchriftPopup(this);
        add(sp);
        addMouseListener(sp);
        kartenzahl++;
        this.f=f;
        this.argumente=f.getArguments();
        Class c=f.getClass();
        this.name=c.getName();
        this.methoden=f.getMethods();
        neuLaden();
    }

    public String getName()
    {
        return name;
    }

    public Argument[] getArgumente()
    {
        return argumente;
    }

    public void paint(Graphics g)
    {
        int rand=5;
        g.setColor(Color.white);
        g.fillRect(0,0,getSize().width,getSize().height);
        g.setColor(Color.lightGray);
        g.fillRect(rand,2,getSize().width-2*rand,getSize().height-4);
        g.setColor(Color.black);
        super.paint(g);
        g.drawRect(rand,2,getSize().width-2*rand,getSize().height-4);
        int y=(int)(getComponent(1).getBounds().getY());
        g.drawLine(rand,y,getSize().width-rand,y);
        y=(int)(getComponent(argumente.length+1).getBounds().getY());
        g.drawLine(rand,y,getSize().width-rand,y);
    }
}
